diff -urNX /home/leigh/.diffex prev_linux-2.4.21-rc6/arch/ppc/platforms/prep_pci.c linux-2.4.21-rc6/arch/ppc/platforms/prep_pci.c
--- prev_linux-2.4.21-rc6/arch/ppc/platforms/prep_pci.c	2003-05-24 13:42:33.000000000 +0100
+++ linux-2.4.21-rc6/arch/ppc/platforms/prep_pci.c	2003-05-29 21:11:57.000000000 +0100
@@ -896,7 +896,7 @@
 ibm_prep_init(void)
 {
 #ifdef CONFIG_PREP_RESIDUAL
-	u32 addr, real_addr, len;
+	u32 addr, real_addr, len, offset;
 	PPC_DEVICE *mpic;
 	PnP_TAG_PACKET *pkt;
 
@@ -918,15 +918,22 @@
 		return;
 
 #define p pkt->L4_Pack.L4_Data.L4_PPCPack
-	if (!((p.PPCData[0] == 2) && (p.PPCData[1] == 32)))
-		return; /* not a 32-bit memory address */
+	if (p.PPCData[1] == 32) {
+		switch (p.PPCData[0]) {
+			case 1:  offset = PREP_ISA_IO_BASE;  break;
+			case 2:  offset = PREP_ISA_MEM_BASE; break;
+			default: return;
+		}
+	}
+	else
+		return;
 
 	real_addr = ld_le32((unsigned int *) (p.PPCData + 4));
 	if (real_addr == 0xffffffff)
 		return;
 
 	/* Adjust address to be as seen by CPU */
-	addr = real_addr + PREP_ISA_MEM_BASE;
+	addr = real_addr + offset;
 
 	len = ld_le32((unsigned int *) (p.PPCData + 12));
 	if (!len)
diff -urNX /home/leigh/.diffex prev_linux-2.4.21-rc6/include/asm-ppc/open_pic.h linux-2.4.21-rc6/include/asm-ppc/open_pic.h
--- prev_linux-2.4.21-rc6/include/asm-ppc/open_pic.h	2003-05-24 14:24:38.000000000 +0100
+++ linux-2.4.21-rc6/include/asm-ppc/open_pic.h	2003-05-29 21:11:57.000000000 +0100
@@ -23,7 +23,7 @@
 
 #define OPENPIC_VEC_TIMER	64	/* and up */
 #define OPENPIC_VEC_IPI		72	/* and up */
-#define OPENPIC_VEC_SPURIOUS	127
+#define OPENPIC_VEC_SPURIOUS	239
 
 /* OpenPIC IRQ controller structure */
 extern struct hw_interrupt_type open_pic;
